﻿using System;
using System.Threading;
using System.Threading.Tasks;
using System.Diagnostics;
using static System.Console;

namespace PracaZZadaniami
{
   class Program
   {
      static void Main(string[] args)
      {
         OutputEncoding = new System.Text.UTF8Encoding();

         var stoper = Stopwatch.StartNew();
         //WriteLine("Uruchamianie metod synchroniczne, w jednym wątku.");
         //MetodaA();
         //MetodaB();
         //MetodaC();

         /*WriteLine("Uruchamianie metod asynchroniczne, w wielu wątkach.");
         Task zadanieA = new Task(MetodaA);
         zadanieA.Start();
         Task zadanieB = Task.Factory.StartNew(MetodaB);
         Task zadanieC = Task.Run(new Action(MetodaC));

         Task[] zadania = { zadanieA, zadanieB, zadanieC };
         Task.WaitAll(zadania); */

         WriteLine("Przekazywanie wyniku jednej metody na wejście kolejnej.");
         var zadanieWywolajSerwisWWWaPotemBazeDanych =
         Task.Factory.StartNew(WywolajSerwisWWW).
         ContinueWith(poprzednieZadanie => WywolajProcedureOsadzona(poprzednieZadanie.Result));
         WriteLine($"{zadanieWywolajSerwisWWWaPotemBazeDanych.Result}");

         WriteLine($"Upłynęło {stoper.ElapsedMilliseconds:#,##0}ms.");
         WriteLine("Naciśnij klawisz ENTER aby zakończyć.");
         ReadLine();
      }

      static void MetodaA()
      {
         WriteLine("Uruchomienie metody A...");
         Thread.Sleep(3000); // symulowanie pracy przez 3 sekundy
         WriteLine("Zakończenie metody A.");
      }
      static void MetodaB()
      {
         WriteLine("Uruchomienie metody B...");
         Thread.Sleep(2000); // symulowanie pracy przez 2 sekundy
         WriteLine("Zakończenie metody B.");
      }
      static void MetodaC()
      {
         WriteLine("Uruchomienie metody C...");
         Thread.Sleep(1000); // symulowanie pracy przez 1 sekundę
         WriteLine("Zakończenie metody C.");
      }

      static decimal WywolajSerwisWWW()
      {
         WriteLine("Uruchamiam wywołanie seriwsu WWW...");
         Thread.Sleep((new Random()).Next(2000, 4000));
         WriteLine("Zakończone wywołanie serwisu WWW.");
         return 89.99M;
      }
      static string WywolajProcedureOsadzona(decimal kwota)
      {
         WriteLine("Uruchamiam wywołanie procedury osadzonej...");
         Thread.Sleep((new Random()).Next(2000, 4000));
         WriteLine("Zakończone wywołanie procedury osadzonej.");
         return $"12 produktów kosztuje więcej niż {kwota:C}.";
      }
   }
}
